# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IdTokenResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'username': 'str',
        'email': 'str',
        'domain': 'str',
        'acct': 'str',
        'context': 'str',
        'sub': 'str',
        'iss': 'str',
        'iat': 'int',
        'exp': 'int',
        'aud': 'list[str]',
        'given_name': 'str',
        'family_name': 'str',
        'email_verified': 'bool',
        'group_names': 'list[str]',
        'group_ids': 'list[str]',
        'context_name': 'str',
        'auth_time': 'int'
    }

    attribute_map = {
        'username': 'username',
        'email': 'email',
        'domain': 'domain',
        'acct': 'acct',
        'context': 'context',
        'sub': 'sub',
        'iss': 'iss',
        'iat': 'iat',
        'exp': 'exp',
        'aud': 'aud',
        'given_name': 'given_name',
        'family_name': 'family_name',
        'email_verified': 'email_verified',
        'group_names': 'group_names',
        'group_ids': 'group_ids',
        'context_name': 'context_name',
        'auth_time': 'auth_time'
    }

    def __init__(self, username=None, email=None, domain=None, acct=None, context=None, sub=None, iss=None, iat=None, exp=None, aud=None, given_name=None, family_name=None, email_verified=None, group_names=None, group_ids=None, context_name=None, auth_time=None):  # noqa: E501
        """IdTokenResponse - a model defined in Swagger"""  # noqa: E501
        self._username = None
        self._email = None
        self._domain = None
        self._acct = None
        self._context = None
        self._sub = None
        self._iss = None
        self._iat = None
        self._exp = None
        self._aud = None
        self._given_name = None
        self._family_name = None
        self._email_verified = None
        self._group_names = None
        self._group_ids = None
        self._context_name = None
        self._auth_time = None
        self.discriminator = None
        if username is not None:
            self.username = username
        if email is not None:
            self.email = email
        if domain is not None:
            self.domain = domain
        if acct is not None:
            self.acct = acct
        if context is not None:
            self.context = context
        if sub is not None:
            self.sub = sub
        if iss is not None:
            self.iss = iss
        if iat is not None:
            self.iat = iat
        if exp is not None:
            self.exp = exp
        if aud is not None:
            self.aud = aud
        if given_name is not None:
            self.given_name = given_name
        if family_name is not None:
            self.family_name = family_name
        if email_verified is not None:
            self.email_verified = email_verified
        if group_names is not None:
            self.group_names = group_names
        if group_ids is not None:
            self.group_ids = group_ids
        if context_name is not None:
            self.context_name = context_name
        if auth_time is not None:
            self.auth_time = auth_time

    @property
    def username(self):
        """Gets the username of this IdTokenResponse.  # noqa: E501

        The user's username.  # noqa: E501

        :return: The username of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this IdTokenResponse.

        The user's username.  # noqa: E501

        :param username: The username of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def email(self):
        """Gets the email of this IdTokenResponse.  # noqa: E501

        The user's email.  # noqa: E501

        :return: The email of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this IdTokenResponse.

        The user's email.  # noqa: E501

        :param email: The email of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def domain(self):
        """Gets the domain of this IdTokenResponse.  # noqa: E501

        The domain the user belongs to.  # noqa: E501

        :return: The domain of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this IdTokenResponse.

        The domain the user belongs to.  # noqa: E501

        :param domain: The domain of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._domain = domain

    @property
    def acct(self):
        """Gets the acct of this IdTokenResponse.  # noqa: E501

        The user's account identifier, the acct claim can be a combination of the user's username and domain in URLEncoded(username)@domain format or the user's email or the UPN of the user.  # noqa: E501

        :return: The acct of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._acct

    @acct.setter
    def acct(self, acct):
        """Sets the acct of this IdTokenResponse.

        The user's account identifier, the acct claim can be a combination of the user's username and domain in URLEncoded(username)@domain format or the user's email or the UPN of the user.  # noqa: E501

        :param acct: The acct of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._acct = acct

    @property
    def context(self):
        """Gets the context of this IdTokenResponse.  # noqa: E501

        The context in which the token was issued.  # noqa: E501

        :return: The context of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this IdTokenResponse.

        The context in which the token was issued.  # noqa: E501

        :param context: The context of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._context = context

    @property
    def sub(self):
        """Gets the sub of this IdTokenResponse.  # noqa: E501

        The user on behalf of which the token was issued.  # noqa: E501

        :return: The sub of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._sub

    @sub.setter
    def sub(self, sub):
        """Sets the sub of this IdTokenResponse.

        The user on behalf of which the token was issued.  # noqa: E501

        :param sub: The sub of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._sub = sub

    @property
    def iss(self):
        """Gets the iss of this IdTokenResponse.  # noqa: E501

        The issuer of the token (URL of Identity Service).  # noqa: E501

        :return: The iss of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._iss

    @iss.setter
    def iss(self, iss):
        """Sets the iss of this IdTokenResponse.

        The issuer of the token (URL of Identity Service).  # noqa: E501

        :param iss: The iss of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._iss = iss

    @property
    def iat(self):
        """Gets the iat of this IdTokenResponse.  # noqa: E501

        Timestamp, measured in number of seconds since 1/1/1970 UTC, indicating when the token was issued.  # noqa: E501

        :return: The iat of this IdTokenResponse.  # noqa: E501
        :rtype: int
        """
        return self._iat

    @iat.setter
    def iat(self, iat):
        """Sets the iat of this IdTokenResponse.

        Timestamp, measured in number of seconds since 1/1/1970 UTC, indicating when the token was issued.  # noqa: E501

        :param iat: The iat of this IdTokenResponse.  # noqa: E501
        :type: int
        """

        self._iat = iat

    @property
    def exp(self):
        """Gets the exp of this IdTokenResponse.  # noqa: E501

        Timestamp, measured in number of seconds since 1/1/1970 UTC, indicating when the token will expire.  # noqa: E501

        :return: The exp of this IdTokenResponse.  # noqa: E501
        :rtype: int
        """
        return self._exp

    @exp.setter
    def exp(self, exp):
        """Sets the exp of this IdTokenResponse.

        Timestamp, measured in number of seconds since 1/1/1970 UTC, indicating when the token will expire.  # noqa: E501

        :param exp: The exp of this IdTokenResponse.  # noqa: E501
        :type: int
        """

        self._exp = exp

    @property
    def aud(self):
        """Gets the aud of this IdTokenResponse.  # noqa: E501

        The list of audience(s). OAuth client(s) the token is issued to.  # noqa: E501

        :return: The aud of this IdTokenResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._aud

    @aud.setter
    def aud(self, aud):
        """Sets the aud of this IdTokenResponse.

        The list of audience(s). OAuth client(s) the token is issued to.  # noqa: E501

        :param aud: The aud of this IdTokenResponse.  # noqa: E501
        :type: list[str]
        """

        self._aud = aud

    @property
    def given_name(self):
        """Gets the given_name of this IdTokenResponse.  # noqa: E501

        The user's given name.  # noqa: E501

        :return: The given_name of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._given_name

    @given_name.setter
    def given_name(self, given_name):
        """Sets the given_name of this IdTokenResponse.

        The user's given name.  # noqa: E501

        :param given_name: The given_name of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._given_name = given_name

    @property
    def family_name(self):
        """Gets the family_name of this IdTokenResponse.  # noqa: E501

        The user's family name.  # noqa: E501

        :return: The family_name of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._family_name

    @family_name.setter
    def family_name(self, family_name):
        """Sets the family_name of this IdTokenResponse.

        The user's family name.  # noqa: E501

        :param family_name: The family_name of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._family_name = family_name

    @property
    def email_verified(self):
        """Gets the email_verified of this IdTokenResponse.  # noqa: E501

        True if the user's e-mail address has been verified; otherwise false.  # noqa: E501

        :return: The email_verified of this IdTokenResponse.  # noqa: E501
        :rtype: bool
        """
        return self._email_verified

    @email_verified.setter
    def email_verified(self, email_verified):
        """Sets the email_verified of this IdTokenResponse.

        True if the user's e-mail address has been verified; otherwise false.  # noqa: E501

        :param email_verified: The email_verified of this IdTokenResponse.  # noqa: E501
        :type: bool
        """

        self._email_verified = email_verified

    @property
    def group_names(self):
        """Gets the group_names of this IdTokenResponse.  # noqa: E501

        Names of the groups the user belongs to.  # noqa: E501

        :return: The group_names of this IdTokenResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_names

    @group_names.setter
    def group_names(self, group_names):
        """Sets the group_names of this IdTokenResponse.

        Names of the groups the user belongs to.  # noqa: E501

        :param group_names: The group_names of this IdTokenResponse.  # noqa: E501
        :type: list[str]
        """

        self._group_names = group_names

    @property
    def group_ids(self):
        """Gets the group_ids of this IdTokenResponse.  # noqa: E501

        Identifiers of the groups the user belongs to.  # noqa: E501

        :return: The group_ids of this IdTokenResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this IdTokenResponse.

        Identifiers of the groups the user belongs to.  # noqa: E501

        :param group_ids: The group_ids of this IdTokenResponse.  # noqa: E501
        :type: list[str]
        """

        self._group_ids = group_ids

    @property
    def context_name(self):
        """Gets the context_name of this IdTokenResponse.  # noqa: E501

        The context name in which the token was issued.  # noqa: E501

        :return: The context_name of this IdTokenResponse.  # noqa: E501
        :rtype: str
        """
        return self._context_name

    @context_name.setter
    def context_name(self, context_name):
        """Sets the context_name of this IdTokenResponse.

        The context name in which the token was issued.  # noqa: E501

        :param context_name: The context_name of this IdTokenResponse.  # noqa: E501
        :type: str
        """

        self._context_name = context_name

    @property
    def auth_time(self):
        """Gets the auth_time of this IdTokenResponse.  # noqa: E501

        Timestamp, measured in number of seconds since 1/1/1970 UTC, indicating when the user was originally authenticated.  # noqa: E501

        :return: The auth_time of this IdTokenResponse.  # noqa: E501
        :rtype: int
        """
        return self._auth_time

    @auth_time.setter
    def auth_time(self, auth_time):
        """Sets the auth_time of this IdTokenResponse.

        Timestamp, measured in number of seconds since 1/1/1970 UTC, indicating when the user was originally authenticated.  # noqa: E501

        :param auth_time: The auth_time of this IdTokenResponse.  # noqa: E501
        :type: int
        """

        self._auth_time = auth_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IdTokenResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IdTokenResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
